var $AdfEventUtils$$ = {addListener:function($listenerArray$$2$$, $instance$$33$$, $listener$$113$$) {
  $AdfAssert$$.$assertArrayOrNull$($listenerArray$$2$$);
  $AdfAssert$$.$assertFunction$($listener$$113$$);
  null == $listenerArray$$2$$ && ($listenerArray$$2$$ = []);
  $listenerArray$$2$$.push($instance$$33$$);
  $listenerArray$$2$$.push($listener$$113$$);
  return $listenerArray$$2$$;
}};
$goog$exportSymbol$$("AdfEventUtils.addListener", $AdfEventUtils$$.addListener);
$AdfEventUtils$$.removeListener = function $$AdfEventUtils$$$removeListener$($listenerArray$$3$$, $listener$$114$$, $instance$$34$$) {
  $AdfAssert$$.$assertArray$($listenerArray$$3$$);
  for (var $size$$69$$ = $listenerArray$$3$$.length, $i$$711$$ = 1;$i$$711$$ < $size$$69$$;$i$$711$$ += 2) {
    if ($listenerArray$$3$$[$i$$711$$] == $listener$$114$$ && $listenerArray$$3$$[$i$$711$$ - 1] == $instance$$34$$) {
      if (2 == $size$$69$$) {
        return null;
      }
      $listenerArray$$3$$.splice($i$$711$$ - 1, 2);
      break;
    }
  }
  return $listenerArray$$3$$;
};
$goog$exportSymbol$$("AdfEventUtils.removeListener", $AdfEventUtils$$.removeListener);
$AdfEventUtils$$.$firePropertyChangeEvent$ = function $$AdfEventUtils$$$$firePropertyChangeEvent$$($listenerArray$$4$$, $source$$203$$, $propertyName$$53$$, $oldValue$$115$$, $newValue$$187$$) {
  $AdfAssert$$.$assertArrayOrNull$($listenerArray$$4$$);
  $AdfAssert$$.assert(null != $source$$203$$);
  $AdfAssert$$.$assertString$($propertyName$$53$$);
  $listenerArray$$4$$ && $oldValue$$115$$ !== $newValue$$187$$ && $AdfEventUtils$$.$deliverEventToListeners$($listenerArray$$4$$, new $AdfPropertyChangeEvent$$($source$$203$$, $propertyName$$53$$, $oldValue$$115$$, $newValue$$187$$));
};
$goog$exportSymbol$$("AdfEventUtils.firePropertyChangeEvent", $AdfEventUtils$$.$firePropertyChangeEvent$);
$AdfEventUtils$$.$deliverEventToListeners$ = function $$AdfEventUtils$$$$deliverEventToListeners$$($listenerArray$$5$$, $event$$320$$) {
  $AdfAssert$$.$assertArray$($listenerArray$$5$$);
  $AdfAssert$$.$assertPrototype$($event$$320$$, $AdfBaseEvent$$);
  for (var $clonedListeners$$ = $listenerArray$$5$$.slice(), $eventSize$$ = $clonedListeners$$.length, $i$$712$$ = 0;$i$$712$$ < $eventSize$$;$i$$712$$ += 2) {
    var $instance$$35$$ = $clonedListeners$$[$i$$712$$], $listener$$115$$ = $clonedListeners$$[$i$$712$$ + 1];
    try {
      null != $instance$$35$$ ? $listener$$115$$.call($instance$$35$$, $event$$320$$) : $listener$$115$$($event$$320$$);
    } catch ($e$$156$$) {
      $AdfLogger$$.$LOGGER$.$logErrorAsWarning$($e$$156$$, " delivering event:" + $event$$320$$ + " to listener:" + $listener$$115$$);
    }
  }
};
$goog$exportSymbol$$("AdfEventUtils.deliverEventToListeners", $AdfEventUtils$$.$deliverEventToListeners$);
$AdfEventUtils$$.addEventListener = function $$AdfEventUtils$$$addEventListener$($listeners$$19$$, $eventType$$53$$, $listener$$116$$, $instance$$36$$) {
  $AdfAssert$$.$assertFunction$($listener$$116$$);
  $AdfAssert$$.assert("function" != typeof $instance$$36$$);
  $listeners$$19$$ || ($listeners$$19$$ = {});
  var $oldListener$$ = $listeners$$19$$[$eventType$$53$$];
  if (null != $oldListener$$ || null != $instance$$36$$) {
    var $array$$28$$;
    $AdfCollections$$.isArray($oldListener$$) ? $array$$28$$ = $oldListener$$ : ($array$$28$$ = [], $oldListener$$ && $array$$28$$.push($oldListener$$));
    $AdfAssert$$.$assertArray$($array$$28$$);
    null != $instance$$36$$ && $array$$28$$.push($instance$$36$$);
    $array$$28$$.push($listener$$116$$);
    $listeners$$19$$[$eventType$$53$$] = $array$$28$$;
  } else {
    $listeners$$19$$[$eventType$$53$$] = $listener$$116$$;
  }
  return $listeners$$19$$;
};
$goog$exportSymbol$$("AdfEventUtils.addEventListener", $AdfEventUtils$$.addEventListener);
$AdfEventUtils$$.removeEventListener = function $$AdfEventUtils$$$removeEventListener$($listeners$$20$$, $eventType$$54$$, $listener$$117_oldLength$$, $instance$$37$$) {
  $AdfAssert$$.$assertFunction$($listener$$117_oldLength$$);
  $AdfAssert$$.assert("function" != typeof $instance$$37$$);
  if (null != $listeners$$20$$) {
    var $oldListeners$$ = $listeners$$20$$[$eventType$$54$$];
    if (null != $oldListeners$$) {
      if ($AdfCollections$$.isArray($oldListeners$$)) {
        $AdfAssert$$.$assertArray$($oldListeners$$);
        for (var $length$$101$$ = $oldListeners$$.length, $i$$713$$ = 0;$i$$713$$ < $length$$101$$;$i$$713$$++) {
          var $value$$273$$ = $oldListeners$$[$i$$713$$];
          if ("function" != typeof $value$$273$$) {
            if ($value$$273$$ == $instance$$37$$ && $oldListeners$$[$i$$713$$ + 1] == $listener$$117_oldLength$$) {
              $oldListeners$$.splice($i$$713$$, 2);
              break;
            }
            $i$$713$$++;
          } else {
            if ($value$$273$$ == $listener$$117_oldLength$$ && null == $instance$$37$$) {
              $oldListeners$$.splice($i$$713$$, 1);
              break;
            }
          }
        }
        $listener$$117_oldLength$$ = $oldListeners$$.length;
        1 == $listener$$117_oldLength$$ ? $listeners$$20$$[$eventType$$54$$] = $oldListeners$$[0] : 0 == $listener$$117_oldLength$$ && ($listeners$$20$$[$eventType$$54$$] = null);
      } else {
        $oldListeners$$ == $listener$$117_oldLength$$ && ($listeners$$20$$[$eventType$$54$$] = null);
      }
    }
  }
  return $listeners$$20$$;
};
$goog$exportSymbol$$("AdfEventUtils.removeEventListener", $AdfEventUtils$$.removeEventListener);
